searchNodes=[{"ref":"Retry.html","title":"Retry","type":"module","doc":"Provides a convenient interface to retrying behavior. All durations are specified in milliseconds. Examples use Retry import Stream retry with: exponential_backoff |&gt; randomize |&gt; cap(1_000) |&gt; expiry(10_000) do # interact with external service end retry with: linear_backoff(10, 2) |&gt; cap(1_000) |&gt; take(10) do # interact with external service end retry with: cycle([500]) |&gt; take(10) do # interact with external service end The first retry will exponentially increase the delay, fudging each delay up to 10%, until the delay reaches 1 second and then give up after 10 seconds. The second retry will linearly increase the retry by a factor of 2 from 10ms giving up after 10 attempts. The third example shows how we can produce a delay stream using standard Stream functionality. Any stream of integers may be used as the value of with:."},{"ref":"Retry.html#retry/2","title":"Retry.retry/2","type":"macro","doc":"Retry a block of code delaying between each attempt the duration specified by the next item in the with delay stream. If the block returns any of the atoms specified in atoms, a retry will be attempted. Other atoms or atom-result tuples will not be retried. If atoms is not specified, it defaults to [:error]. Similary, if the block raises any of the exceptions specified in rescue_only, a retry will be attempted. Other exceptions will not be retried. If rescue_only is not specified, it defaults to [RuntimeError]. The after block evaluates only when the do block returns a valid value before timeout. On the other hand, the else block evaluates only when the do block remains erroneous after timeout. Example use Retry retry with: exponential_backoff() |&gt; cap(1_000) |&gt; expiry(1_000), rescue_only: [CustomError] do # interact with external service after result -&gt; result else error -&gt; error end"},{"ref":"Retry.html#retry_while/2","title":"Retry.retry_while/2","type":"macro","doc":"Retry a block of code until halt is emitted delaying between each attempt the duration specified by the next item in the with delay stream. The return value for block is expected to be {:cont, result}, return {:halt, result} to end the retry early. Example retry_while with: linear_backoff(500, 1) |&gt; take(5) do call_service |&gt; case do result = %{&quot;errors&quot; =&gt; true} -&gt; {:cont, result} result -&gt; {:halt, result} end end"},{"ref":"Retry.html#wait/2","title":"Retry.wait/2","type":"macro","doc":"Wait for a block of code to be truthy delaying between each attempt the duration specified by the next item in the delay stream. The after block evaluates only when the do block returns a truthy value. On the other hand, the else block evaluates only when the do block remains falsy after timeout. Example wait linear_backoff(500, 1) |&gt; take(5) do we_there_yet? after _ -&gt; {:ok, &quot;We have arrived!&quot;} else _ -&gt; {:error, &quot;We&#39;re still on our way :(&quot;} end"},{"ref":"Retry.DelayStreams.html","title":"Retry.DelayStreams","type":"module","doc":"This module provide a set of helper functions that produce delay streams for use with retry."},{"ref":"Retry.DelayStreams.html#cap/2","title":"Retry.DelayStreams.cap/2","type":"function","doc":"Returns a stream that is the same as delays except that the delays never exceed max. This allow capping the delay between attempts to some max value. Example retry with: exponential_backoff() |&gt; cap(10_000) do # ... end Produces an exponentially increasing delay stream until the delay reaches 10 seconds at which point it stops increasing"},{"ref":"Retry.DelayStreams.html#constant_backoff/1","title":"Retry.DelayStreams.constant_backoff/1","type":"function","doc":"Returns a constant stream of delays. Example retry with: constant_backoff(50) do # ... end"},{"ref":"Retry.DelayStreams.html#exp_backoff/1","title":"Retry.DelayStreams.exp_backoff/1","type":"function","doc":"Returns a stream of delays that increase exponentially. Example retry with: exp_backoff do # ... end"},{"ref":"Retry.DelayStreams.html#expiry/3","title":"Retry.DelayStreams.expiry/3","type":"function","doc":"Returns a delay stream that is the same as delays except it limits the total life span of the stream to time_budget. This calculation takes the execution time of the block being retried into account. The execution of the code within the block will not be interrupted, so the total time of execution may run over the time_budget depending on how long a single try will take. Optionally, you can specify a minimum delay so the smallest value doesn&#39;t go below the threshold. Example retry with: exponential_backoff() |&gt; expiry(1_000) do # ... end Produces a delay stream that ends after 1 second has elapsed since its creation."},{"ref":"Retry.DelayStreams.html#exponential_backoff/2","title":"Retry.DelayStreams.exponential_backoff/2","type":"function","doc":"Returns a stream of delays that increase exponentially. Example retry with: exponential_backoff do # ... end"},{"ref":"Retry.DelayStreams.html#jitter/1","title":"Retry.DelayStreams.jitter/1","type":"function","doc":"Returns a stream in which each element of delays is randomly adjusted to a number between 1 and the original delay. Example retry with: exponential_backoff() |&gt; jitter() do # ... end"},{"ref":"Retry.DelayStreams.html#lin_backoff/2","title":"Retry.DelayStreams.lin_backoff/2","type":"function","doc":"Returns a stream of delays that increase linearly. Example retry with: lin_backoff(@fibonacci) do # ... end"},{"ref":"Retry.DelayStreams.html#linear_backoff/2","title":"Retry.DelayStreams.linear_backoff/2","type":"function","doc":"Returns a stream of delays that increase linearly. Example retry with: linear_backoff(50, 2) do # ... end"},{"ref":"Retry.DelayStreams.html#randomize/2","title":"Retry.DelayStreams.randomize/2","type":"function","doc":"Returns a stream in which each element of delays is randomly adjusted no more than proportion of the delay. Example retry with: exponential_backoff() |&gt; randomize do # ... end Produces an exponentially increasing delay stream where each delay is randomly adjusted to be within 10 percent of the original value"}]